//
//  AppDelegate.m
//  AlibcTradeDemo
//
//

#import "AppDelegate.h"
#import "ViewController.h"
#import <AlibcTradeUltimateSDK/AlibcTradeUltimateSDK.h>

// 媒体电商套件图片库协议实现
#import "ALITradeDemoImageLoader.h"
#import <WindmillWeaver/WMLHandlerFactory.h>

// 电商套件外跳媒体页面实现
#import "ALiTradeDemoURLHandler.h"
#import <AlibcTradeContainer/AlibcTradeMiniAppURLRouter.h>

#import "ALITradeDemoZipArchiver.h"

@interface AppDelegate ()

// 图片库实现
@property (nonatomic,strong)ALITradeDemoImageLoader *imageLoaderImp;

// 外跳路由协议实现
@property (nonatomic,strong)ALiTradeDemoURLHandler *urlHandlerImp;

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    //Init
    ViewController *mainVC = [[ViewController alloc] init];
    mainVC.tabBarItem.title = @"AlibcUltimateSDK";
    mainVC.view.backgroundColor = [UIColor yellowColor];
    
    UITabBarController   *tabBarView= [[UITabBarController alloc] init];
    tabBarView.viewControllers=@[mainVC];
    tabBarView.title= @"AlibcUltimateSDK:5.0.0.0";
    tabBarView.edgesForExtendedLayout=UIRectEdgeNone;
    tabBarView.extendedLayoutIncludesOpaqueBars=NO;
    tabBarView.navigationController.navigationBar.translucent=NO;
    
    self.window = [[UIWindow alloc] initWithFrame:[UIScreen mainScreen].bounds];
    self.window.backgroundColor = [UIColor whiteColor];
    self.window.rootViewController = [[UINavigationController alloc] initWithRootViewController:tabBarView];
    
    [self.window makeKeyAndVisible];
    
    __weak typeof(self) weakSelf = self;
    // 打开日志开关
    [[AlibcTradeUltimateSDK sharedInstance] setDebugLogOpen:YES];
    [[AlibcTradeUltimateSDK sharedInstance] asyncInitWithSuccess:^{
        NSLog(@"百川初始化成功");
        __strong typeof(self) self = weakSelf;
        
        // 注册Zip解压能力
        [WMLHandlerFactory registerHandler:[ALITradeDemoZipArchiver new] withProtocol:@protocol(TRVZipArchiveProtocol)];
        
        // 注册图片库协议
        self.imageLoaderImp = [ALITradeDemoImageLoader new];
        [WMLHandlerFactory registerHandler:self.imageLoaderImp withProtocol:@protocol(WMLImageLoaderProtocol)];
        
        // 注册电商套件外跳媒体路由协议实现
        self.urlHandlerImp = [ALiTradeDemoURLHandler new];
        [[AlibcTradeMiniAppURLRouter sharedInstance] addMiniAppRouterListener:self.urlHandlerImp];
        
        // 打开套件默认显示自检工具
        [[AlibcTradeUltimateSDK sharedInstance] enableAutoShowDebug:YES];
    } failure:^(NSError * _Nonnull error) {
        NSLog(@"百川初始化失败");
    }];
    return YES;
}

- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey,id> *)options {
    return [[AlibcTradeUltimateSDK sharedInstance] application:app openURL:url options:options];
}


@end
