//
//  ViewController.m
//  AlibcTradeDemo
//
//

#import "ViewController.h"
//#import <AlibabaAuthEntrance/ALBBSDK.h>
//#import <AlibabaAuthEntrance/ALBBCompatibleSession.h>
#import "ALiTradeDemoShareParam.h"
#import <AlibcTradeUltimateSDK/AlibcTradeUltimateSDK.h>

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
     // Do any additional setup after loading the view.
     [self initTitles];
     [self initClassNames];
     [self initTableView];
}

- (void)initTableView {
  self.tableView = [[UITableView alloc] initWithFrame:self.view.bounds
                                                style:UITableViewStylePlain];
  self.tableView.autoresizingMask =
      UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
  self.tableView.delegate = self;
  self.tableView.dataSource = self;

  [self.view addSubview:self.tableView];
}

- (void)initTitles {
    self.titles = [NSArray arrayWithObjects: @[MODULE_SETTINGAPIPARAMQDEMO],@[MODULE_OPENEWEBVIEWQDEMO, MODULE_OPENEMINIAPPQDEMO],@[MODULE_LOGINQDEMO,
    MODULE_LOGOUTQDEMO,MODULE_TOPAUTH], nil];
}

- (void)initClassNames {
  self.classNames = [NSArray arrayWithObjects:@[MODULE_SETTINGAPIPARAM_CLASS],
    @[MODULE_OPENEWEBVIEW_CLASS ,MODULE_OPENEMINIAPPQDEMO_CLASS],
    @[MODULE_LOGIN_CLASS, MODULE_LOGOUT_CLASS,MODULE_TOPAUTH_CLASS]
  ,nil];
}

#pragma mark -Delegate
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 3;
}

- (NSInteger)tableView:(UITableView *)tableView
    numberOfRowsInSection:(NSInteger)section {
  return [self.titles[section] count];
}

- (NSString *)tableView:(UITableView *)tableView
    titleForHeaderInSection:(NSInteger)section {
  switch (section) {
  case 0:
    return @"SDK环境";
    break;
  case 1:
    return @"SDK API参数设置";
    break;
  case 2:
    return @"SDK功能";
    break;
  default:
    return @"";
    break;
  }
}

- (UITableViewCell *)tableView:(UITableView *)tableView
         cellForRowAtIndexPath:(NSIndexPath *)indexPath {
  static NSString *mainViewController = @"MainViewController";
  UITableViewCell *cell =
      [tableView dequeueReusableCellWithIdentifier:mainViewController];
  if (cell == nil) {
    cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle
                                  reuseIdentifier:mainViewController];
    cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
  }
  cell.textLabel.text = self.titles[indexPath.section][indexPath.row];
  cell.detailTextLabel.text = self.classNames[indexPath.section][indexPath.row];
  return cell;
}

#pragma mark - UITableViewDelegate

- (void)tableView:(UITableView *)tableView
    didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
  [tableView deselectRowAtIndexPath:indexPath animated:YES];
  NSString *className = self.classNames[indexPath.section][indexPath.row];

  if ([className isEqualToString:@"login"]) {
      if (![[[AlibcTradeUltimateSDK sharedInstance] loginService] isLogin]) {
          [[[AlibcTradeUltimateSDK sharedInstance] loginService] setH5Only:NO];
          [[[AlibcTradeUltimateSDK sharedInstance] loginService] auth:self success:^(AlibcUser *user) {
              NSLog(@"登录成功");
          } failure:^(NSError *error) {
              NSLog(@"登录失败");
          }];
      } else {
          AlibcUser *userInfo = [[[AlibcTradeUltimateSDK sharedInstance] loginService] getUser];
          NSLog(@"已登录");
      }
  } else if ([className isEqualToString:@"logout"]) {
    [[[AlibcTradeUltimateSDK sharedInstance] loginService] logout];
    NSLog(@"已登出");
  } else if ([className isEqualToString:MODULE_TOPAUTH_CLASS]) {
      [[AlibcTradeUltimateSDK sharedInstance].tradeService authorize4AppKey:nil appName:@"测试" appLogo:nil currentVC:self.tabBarController callBack:^(NSError *error, NSString *accessToken, NSString *expire) {
          NSLog(@"%@ - %@",accessToken,expire);
      }];
  }

  UIViewController *subViewController =
      [[NSClassFromString(className) alloc] init];
  subViewController.title = self.titles[indexPath.section][indexPath.row];
  [self.navigationController
      pushViewController:(UIViewController *)subViewController
                animated:NO];
}

@end
