//
//  ALiTradeDemoOpenTradePageByCodeViewController.m
//  NBUltimateDemo
//
//

#import "ALiTradeDemoOpenTradePageByCodeViewController.h"
#import <AlibcTradeUltimateSDK/AlibcTradeUltimateSDK.h>
#import "ALiTradeDemoShareParam.h"

@interface ALiTradeDemoOpenTradePageByCodeViewController ()

@property(nonatomic, copy) NSString *funcCodeStr;
@property(nonatomic, copy) NSString *bizParamsStr;

@end

@implementation ALiTradeDemoOpenTradePageByCodeViewController

- (void)viewDidLoad {
  [super viewDidLoad];
  // Do any additional setup after loading the view from its nib.
    _funcCode.text = _funcCodeStr = @"suite://bc.suite.live/bc.template.live.list";
  NSData *data = [NSJSONSerialization
      dataWithJSONObject:[ALiTradeDemoShareParam sharedInstance].bizParams
                 options:NSJSONWritingPrettyPrinted
                   error:nil];
  NSString *biz =
      [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
  _bizParams.text = _bizParamsStr = biz;
    
    [[UIApplication sharedApplication] setApplicationSupportsShakeToEdit:YES];
}
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self becomeFirstResponder];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [self resignFirstResponder];
}

#pragma mark - ShakeToEdit
- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event
{
    [[AlibcTradeUltimateSDK sharedInstance] showLocalDebugTool:self];
}

- (IBAction)codeChanged:(UITextField *)sender {
  _funcCodeStr = sender.text;
}
- (IBAction)bizParamsChanged:(UITextField *)sender {
  _bizParamsStr = sender.text;
}

- (IBAction)openTradePageByCode:(UIButton *)sender {
  if ([_funcCode.text isEqualToString:@""]) {
      NSLog(@"code不能为空");
      return;
  }

  NSData *data = [_bizParams.text dataUsingEncoding:NSUTF8StringEncoding];
  NSError *jerror = nil;
  NSMutableDictionary *jsonObject =
      [NSJSONSerialization JSONObjectWithData:data
                                      options:NSJSONReadingMutableContainers
                                        error:&jerror];

  AlibcTradeUrlParams *urlParams = [AlibcTradeUrlParams new];
  if ([jsonObject objectForKey:@"id"]) {
    urlParams.id = [jsonObject objectForKey:@"id"];
  } else if ([jsonObject objectForKey:@"shopId"]) {
    urlParams.shopId = [jsonObject objectForKey:@"shopId"];
  }

  if ([jsonObject objectForKey:@"bizExtMap"]) {
    NSString *bizStr = [jsonObject objectForKey:@"bizExtMap"];
    if (bizStr != nil) {
      NSData *jsonData = [bizStr dataUsingEncoding:NSUTF8StringEncoding];
      NSError *err;
      NSDictionary *dic =
          [NSJSONSerialization JSONObjectWithData:jsonData
                                          options:NSJSONReadingMutableContainers
                                            error:&err];
      if (err) {
        NSLog(@"json解析失败：%@", err);
          return;
      }
        
       urlParams.bizExtMap = dic;
    }
  }

  // 构造showParam
  AlibcTradeShowParams *showParams = [AlibcTradeShowParams new];
  showParams.failMode = [ALiTradeDemoShareParam sharedInstance].nativeFailMode;
  showParams.isNeedOpenByAliApp =
      [ALiTradeDemoShareParam sharedInstance].isNeedOpenByAliApp;
  showParams.isPushBCWebView =
      [ALiTradeDemoShareParam sharedInstance].isNeedPushWebView;
  if ([ALiTradeDemoShareParam sharedInstance].linkKey) {
    showParams.linkKey = @"tmall";
  } else {
    showParams.linkKey = @"taobao";
  }

  showParams.degradeUrl = [ALiTradeDemoShareParam sharedInstance].degardeUrl;

  // 构造taokeParam
  AlibcTradeTaokeParams *taokeParam = [AlibcTradeTaokeParams new];
  taokeParam.pid = [[ALiTradeDemoShareParam sharedInstance].taoKeParams
      objectForKey:@"pid"];
  taokeParam.unionId = [[ALiTradeDemoShareParam sharedInstance].taoKeParams
      objectForKey:@"unionId"];
  taokeParam.subPid = [[ALiTradeDemoShareParam sharedInstance].taoKeParams
      objectForKey:@"subPid"];
    taokeParam.relationId = [[ALiTradeDemoShareParam sharedInstance].taoKeParams objectForKey:@"relationId"];
    taokeParam.materialSourceUrl = [[ALiTradeDemoShareParam sharedInstance].taoKeParams objectForKey:@"materialSourceUrl"];
  taokeParam.extParams = [[ALiTradeDemoShareParam sharedInstance].taoKeParams
      objectForKey:@"extParams"];

  [[AlibcTradeUltimateSDK sharedInstance].tradeService
      openTradePageByCode:_funcCode.text
   parentController:self.navigationController
                urlParams:urlParams
               showParams:showParams
              taoKeParams:taokeParam
               trackParam:[ALiTradeDemoShareParam sharedInstance].trackParams
          openUrlCallBack:^(NSError *_Nonnull error, NSDictionary *result) {
            if (error) {
                NSLog(@"调用成功");
            } else {
                NSLog(@"调用失败");
            }
          }];
}


@end
